'''
Created on Nov 6, 2012

@author: vikturek
'''

import sys
import os
import random
import shutil
import math
import re
#from Crypto.Random.random import randint

oddMatrixSqrtSize = 999#2289
evenMatrixSqrtSize = 1000#2290

def printUsage():
    print "  !!!\tZadany spatne parametry!\n" 
    print "\tPrvnim parametrem je cesta k referencnimu reseni.\n"
    print "\tDruhym je vyber testovaci sady:"
    print "\t\t1|2|3|4|5|6 - cislo testovaci sady"
    print "\t\tall         - spusti vsechny testovaci sady"
    print "\t\t              a vypise dosazene vysledky.\n"
    print "\tUkazka spusteni vsech testu:\n"
    print "\t\tpython DU2-tester refApp.linux all\n"
    print "\tPro splneni testu 4 je nutne mit nainstalovany"
    print "\t\tvalgrind a testovat na linuxu.\t"
    print "\tPro splneni testu 5 je treba mit nainstalovany perl.\n"

def printMatrix(input):
    if os.path.exists(input):
        matrixFile = file(input)
        matrixFile.seek(0,2)
        lineLength = math.sqrt(matrixFile.tell())
        matrixFile.seek(0, 0)
        for i in range(0, int(lineLength)):
            sys.stdout.write("\t")
            for j in range(0, int(lineLength)):
                sys.stdout.write("%02x " % ord(matrixFile.read(1)))
            print ""
        print ""
    else:
        print "\tSoubor matice nenalezen!\n"

def generateMatrix(fileName, byteSize):
    
    if os.path.exists(fileName):
        os.remove(fileName)
    rand = random
    buffer = " "
    matrixFile = file(fileName, "w")
    for i in range(0, byteSize):
        matrixFile.write(chr(rand.randint(0,255)))
    
matrices = ["0x0",
            "1x1",
            "2x2",
            "3x3",
            "4x4"
            ]

matricesTest1 = ["0x0",
                 "0x0",
                 "1x1",
                 "1x1",
                 "1x1",
                 "1x1",
                 "4x4",
                 "4x4",
                 "1x1",
                 ]
commandsTest1 = [" right 0 0 Inputs/" + matricesTest1[0] + " Outputs/",
                 " right 0 0 Inputs/wrongInput Outputs/",
                 " right 0 0 Inputs/" + matricesTest1[2] + " /dev/Outputs/",
                 " badWord 0 0 Inputs/" + matricesTest1[3] + " Outputs/",
                 " right -1 0 Inputs/" + matricesTest1[4] + " Outputs/",
                 " right 0 -1 Inputs/" + matricesTest1[5] + " Outputs/",
                 " right 16 0 Inputs/" + matricesTest1[6] + " Outputs/",
                 " right 0 8 Inputs/" + matricesTest1[7] + " Outputs/",
                 " left 0 0 Inputs/" + matricesTest1[8] + " Outputs/",
                 ]

matricesTest2 = ["1x1",
                 "1x1",
                 "1x1",
                 "1x1",
                 "2x2", #4
                 "2x2", 
                 "3x3",
                 "3x3",
                 "3x3",
                 "3x3", #9
                 "4x4",
                 "4x4",
                 "4x4",
                 "4x4", 
                 "3x3"
                 ]
commandsTest2 = [" right 0 4 Inputs/" + matricesTest2[0] + " Outputs/",
                 " left 0 4 Inputs/" + matricesTest2[1] + " Outputs/",
                 " right 0 1 Inputs/" + matricesTest2[2] + " Outputs/",
                 " left 0 1 Inputs/" + matricesTest2[3] + " Outputs/",
                 " right 1 2 Inputs/" + matricesTest2[4] + " Outputs/",
                 " left 1 2 Inputs/" + matricesTest2[5] + " Outputs/",
                 " right 1 4 Inputs/" + matricesTest2[6] + " Outputs/",
                 " left 1 4 Inputs/" + matricesTest2[7] + " Outputs/",
                 " right 4 4 Inputs/" + matricesTest2[8] + " Outputs/",
                 " left 4 4 Inputs/" + matricesTest2[9] + " Outputs/",
                 " right 5 7 Inputs/" + matricesTest2[10] + " Outputs/",
                 " left 5 7 Inputs/" + matricesTest2[11] + " Outputs/",
                 " right 1 0 Inputs/" + matricesTest2[12] + " Outputs/",
                 " left 1 0 Inputs/" + matricesTest2[13] + " Outputs/",
                 " right 0 0 Inputs/" + matricesTest2[14] + " Outputs/",
             ]


if __name__ == '__main__':
    
    valgrindEnabled = False
    perlEnabled = False
    
    rand = random
    
    if os.system("valgrind > /dev/null 2> /dev/null 3> /dev/null") >> 8 != 127:
        valgrindEnabled = True
    
    if os.system("perl -h > /dev/null 2> /dev/null") >> 8 != 127:
        perlEnabled = True
    
    print "\n\t******************************************"
    print   "\t* Tester pro domaci ulohu 2 predmetu PJC *"
    print   "\t******************************************\n\n"
    
    if len(sys.argv) < 3:
        printUsage()
        sys.exit(1)
    
    if not os.path.exists(sys.argv[1]):
        print " !!!\tChyba: Nemohu najit zadany soubor referencniho reseni!"
        print "\t\tZkontrolujte, zda mate prislusne referencni reseni"
        print "\t\tumisteno ve slozce s testerem a ma nazev: " + sys.argv[1] + "\n"
        sys.exit(1)
    os.system("chmod +xr " + sys.argv[1] + " > /dev/null")
    if os.system("./" + sys.argv[1] + " > /dev/null 2> /dev/null") >> 8 != 1:
        print " !!!\tChyba: Nemohu spustit referencni reseni!"
        print "\t\tZkontrolujte, zda je zadane referencni reseni urceno"
        print "\t\tpro vasi platformu.\n"
        sys.exit(1);
    
    testChoice = sys.argv[2]
    if testChoice != "1" and testChoice != "2" and testChoice != "3" and testChoice != "4" and testChoice != "5" and testChoice != "6" and testChoice != "all":
        printUsage()
        sys.exit(1)
        
    if os.path.exists("Outputs"):
        shutil.rmtree("Outputs")
    
    os.mkdir("Outputs")
    
    if not os.path.exists("BinarySnakeMatrix.cpp"):
        print "  !!!\tChyba: Nemohu najit zdrojovy kod BinarySnakeMatrix.cpp!\n"
        print "\t\tKod ma byt ve stejne slozce jako tento skript.\n"
        sys.exit(1)
        
    if not os.path.exists("BinarySnakeMatrix.h"):
        print "  !!!\tChyba: Nemohu najit zdrojovy kod testovaneho reseni!"
        print "\tZkontrolujte, zda je soubor BinarySnakeMatrix.h ve slozce s testerem.\n"
        sys.exit(1)
    
    if not os.path.exists("timeout.perl"):
        print "  !!!\tChyba: Nemohu najit soubor timeout.perl!\n"
        print "\t\tKod ma byt ve stejne slozce jako tento skript.\n"
        sys.exit(1)
        
    for i in matrices:
        if not os.path.exists("Inputs/" + i):
            print "  !!!\tChyba: Nemohu najit vstupni soubor Inputs/" + i + ".\n"
            sys.exit(1)
        
    sys.stdout.write("   *\tKompiluji zdrojovy kod ... ");
    
    status = os.system("g++ -g -o testApp -Wall -Werror -pedantic -pedantic-errors  BinarySnakeMatrix.cpp 2> Outputs/compileLog")
    if status != 0:
        print "Chyba!\n"
        print "  !!!\tPreklad zdrojoveho kodu se nezdaril. Log kompilace je v souboru Outputs/compileLog.\n"
        sys.exit(1)
    else:
        print "OK\n"
        
    if testChoice == "1" or testChoice == "all":
        print "  -->\tTestovaci sada 1 - detekce spatnych vstupu\n"
        
        testNumber = 0
        for i in range(0, len(commandsTest1)):
            sys.stdout.write("   *\tTest 1.%02d: " %(testNumber) + commandsTest1[i] + "1.%02d ... " %(testNumber))
            refRet = os.system("./" + sys.argv[1] + commandsTest1[i] + "1.%02dref > Outputs/1.%02dref.txt" %(testNumber, testNumber))
            os.system("./testApp" + commandsTest1[i] + "1.%02dtest > Outputs/1.%02dtest.txt" %(testNumber, testNumber))
            if os.system("diff Outputs/1.%02dref Outputs/1.%02dtest > /dev/null 2> /dev/null" %(testNumber, testNumber)) != 0 and refRet >> 8 != 1:
                print "Chyba\n"
                print "  !!!\t\tVystupni matice Outputs/1.%02dref a Outputs/1.%02dtest se lisi!\n" % (testNumber, testNumber)
                print "Originalni matice:\n"
                printMatrix("Inputs/" + matricesTest1[i])
                print "Referencni matice:\n"
                printMatrix("Outputs/1.%02dref" %(testNumber))
                print "Testovaci matice:\n"
                printMatrix("Outputs/1.%02dtest" %(testNumber))
                    
            elif os.system("diff Outputs/1.%02dref.txt Outputs/1.%02dtest.txt > /dev/null 2> /dev/null" %(testNumber, testNumber)) != 0:
                print "Chyba\n"
                print "  !!!\t\tVystupy Outputs/1.%02dref.txt a Outputs/1.%02dtest.txt se lisi!\n" % (testNumber, testNumber)
            else:
                print "OK\n"
            testNumber = testNumber + 1
        
    if testChoice == "2" or testChoice == "all":
        print "  -->\tTestovaci sada 2 - kontrola rotace - pripravene vstupy\n"
        
        testNumber = 0
        for i in range(0, len(commandsTest2)):
            sys.stdout.write("   *\tTest 2.%02d: " %(testNumber) + commandsTest2[i] + "2.%02d ... " %(testNumber))
            os.system("./" + sys.argv[1] + commandsTest2[i] + "2.%02dref > Outputs/2.%02dref.txt" %(testNumber, testNumber))
            os.system("./testApp" + commandsTest2[i] + "2.%02dtest > Outputs/2.%02dtest.txt" %(testNumber, testNumber))
            if os.system("diff Outputs/2.%02dref Outputs/2.%02dtest > /dev/null 2> /dev/null" %(testNumber, testNumber)) != 0:
                print "Chyba\n"
                print "  !!!\t\tVystupni matice Outputs/2.%02dref a Outputs/2.%02dtest se lisi!\n" % (testNumber, testNumber)
                print "Originalni matice:\n"
                printMatrix("Inputs/" + matricesTest2[i])
                print "Referencni matice:\n"
                printMatrix("Outputs/2.%02dref" %(testNumber))
                print "Testovaci matice:\n"
                printMatrix("Outputs/2.%02dtest" %(testNumber))
            elif os.system("diff Outputs/2.%02dref.txt Outputs/2.%02dtest.txt > /dev/null 2> /dev/null" %(testNumber, testNumber)) != 0:
                print "Chyba\n"
                print "  !!!\t\tVystupy Outputs/2.%02dref.txt a Outputs/2.%02dtest.txt se lisi!\n" % (testNumber, testNumber)
            else:
                print "OK\n"
            testNumber = testNumber + 1
        
    if testChoice == "3" or testChoice == "all":
        print "  -->\tTestovaci sada 3 - kontrola rotace - generovane vstupy\n"
        
        count = 40
        
        sys.stdout.write("   *\tGeneruji nahodne matice ... ")
        for i in range(0, count):
            size = rand.randint(5, 10)
            generateMatrix("Inputs/3.%02d" % i, size * size)
        generateMatrix("Inputs/odd", oddMatrixSqrtSize * oddMatrixSqrtSize)
        generateMatrix("Inputs/even", evenMatrixSqrtSize * evenMatrixSqrtSize)
        print "OK\n"
        
        testNumber = 0
        for i in range(0, count):
            if rand.randint(0,1) == 0:
                command = " right %d %d Inputs/3.%02d Outputs/" % (rand.randint(0, 24), rand.randint(0,7), testNumber)
            else:
                command = " left %d %d Inputs/3.%02d Outputs/" % (rand.randint(0, 24), rand.randint(0,7), testNumber)
            
            sys.stdout.write("   *\tTest 3.%02d: " %(testNumber) + command + "3.%02d ... " %(testNumber)) 
            os.system("./" + sys.argv[1] + command + "3.%02dref > Outputs/3.%02dref.txt" %(testNumber, testNumber))
            os.system("./testApp" + command + "3.%02dtest > Outputs/3.%02dtest.txt" %(testNumber, testNumber))
            if os.system("diff Outputs/3.%02dref Outputs/3.%02dtest > /dev/null 2> /dev/null" %(testNumber, testNumber)) != 0:
                print "Chyba\n"
                print "  !!!\t\tVystupni matice Outputs/3.%02dref a Outputs/3.%02dtest se lisi!\n" % (testNumber, testNumber)
                print "Originalni matice:\n"
                printMatrix("Inputs/3.%02d" % testNumber)
                print "Referencni matice:\n"
                printMatrix("Outputs/3.%02dref" %(testNumber))
                print "Testovaci matice:\n"
                printMatrix("Outputs/3.%02dtest" %(testNumber))
            elif os.system("diff Outputs/3.%02dref.txt Outputs/3.%02dtest.txt > /dev/null 2> /dev/null" %(testNumber, testNumber)) != 0:
                print "Chyba\n"
                print "  !!!\t\tVystupy Outputs/3.%02dref.txt a Outputs/3.%02dtest.txt se lisi!\n" % (testNumber, testNumber)
            else:
                print "OK\n"
            testNumber = testNumber + 1
        
        shiftBytes = rand.randint(1, oddMatrixSqrtSize * oddMatrixSqrtSize - 1)
        shiftBites = rand.randint(1, 7)
        
        sys.stdout.write("   *\tTest 3.%02d: left %d %d Inputs/odd Outputs/3.%02dref ... " %(testNumber, shiftBytes, shiftBites, testNumber))
        os.system("./%s left %d %d Inputs/odd Outputs/3.%02dref > Outputs/3.%02dref.txt" %(sys.argv[1], shiftBytes, shiftBites, testNumber, testNumber))
        os.system("./testApp left %d %d Inputs/odd Outputs/3.%02dtest > Outputs/3.%02dtest.txt" %(shiftBytes, shiftBites, testNumber, testNumber))
        if os.system("diff Outputs/3.%02dref Outputs/3.%02dtest > /dev/null 2> /dev/null" %(testNumber, testNumber) ) != 0:
            print "Chyba\n"
            print "  !!!\t\tVystupni matice Outputs/3.%02dref a Outputs/3.%02dtest se lisi!\n" % (testNumber, testNumber)
            
        elif os.system("diff Outputs/3.%02dref.txt Outputs/3.%02dtest.txt > /dev/null" % (testNumber, testNumber)) != 0:
            print "Chyba\n"
            print "  !!!\t\tVystupy Outputs/3.%02dref.txt a Outputs/3.%02dtest.txt se lisi!\n" % (testNumber, testNumber)
        else:
            print "OK\n"
        testNumber = testNumber + 1
    
        shiftBytes = rand.randint(1, oddMatrixSqrtSize * oddMatrixSqrtSize - 1)
        shiftBites = rand.randint(1, 7)
        
        sys.stdout.write("   *\tTest 3.%02d: left %d %d Inputs/even Outputs/3.%02dref ... " %(testNumber, shiftBytes, shiftBites, testNumber))
        os.system("./%s left %d %d Inputs/even Outputs/3.%02dref > Outputs/3.%02dref.txt" %(sys.argv[1], shiftBytes, shiftBites, testNumber, testNumber))
        os.system("./testApp left %d %d Inputs/even Outputs/3.%02dtest > Outputs/3.%02dtest.txt" %(shiftBytes, shiftBites, testNumber, testNumber))
        if os.system("diff Outputs/3.%02dref Outputs/3.%02dtest > /dev/null 2> /dev/null" %(testNumber, testNumber) ) != 0:
            print "Chyba\n"
            print "  !!!\t\tVystupni matice Outputs/3.%02dref a Outputs/3.%02dtest se lisi!\n" % (testNumber, testNumber)
            
        elif os.system("diff Outputs/3.%02dref.txt Outputs/3.%02dtest.txt > /dev/null" % (testNumber, testNumber)) != 0:
            print "Chyba\n"
            print "  !!!\t\tVystupy Outputs/3.%02dref.txt a Outputs/3.%02dtest.txt se lisi!\n" % (testNumber, testNumber)
        else:
            print "OK\n"
        
                
    if testChoice == "4" or testChoice == "all":
        print "  -->\tTestovaci sada 4 - kontrola prace s pameti\n"
        
        if not valgrindEnabled:
            print "  !!!\tChyba: Nemohu provest test prace s pameti!\n"
            print "\t\tNastroj valgrind nebyl v systemu nalezen.\n"
        else:
            if (not os.path.exists("Inputs/odd")) or (not os.path.exists("Inputs/even")):
                sys.stdout.write("   *\tGeneruji nahodne matice ... ")
                generateMatrix("Inputs/odd", oddMatrixSqrtSize * oddMatrixSqrtSize)
                generateMatrix("Inputs/even", evenMatrixSqrtSize * evenMatrixSqrtSize)
                print "OK\n"
            
            testNumber = 0
            for i in range(0, len(commandsTest1)):
                sys.stdout.write("   *\tTest 4.%02d: " %(testNumber) + commandsTest1[i] + "trash ... ")
                if os.system("valgrind --error-exitcode=1 ./testApp" + commandsTest1[i] + "trash >/dev/null 2> Outputs/4.%02d.txt" ) == 1:
                    print "Chyba\n"
                else:
                    print "OK\n"  
                testNumber = testNumber + 1
            
            shiftBytes = rand.randint(0, oddMatrixSqrtSize * oddMatrixSqrtSize - 1)
            shiftBites = rand.randint(0, 7)
                
            sys.stdout.write("   *\tTest 4.%02d:  left %d %d Inputs/odd Outputs/trash ... "  %(testNumber, shiftBytes, shiftBites))
            if os.system("valgrind --error-exitcode=1 ./testApp left %d %d Inputs/odd Outputs/trash >/dev/null 2> Outputs/4.%02d.txt" % (shiftBytes, shiftBites, testNumber)) != 0:
                print "Chyba\n"
            else:
                print "OK\n"  
            testNumber = testNumber + 1
            
            sys.stdout.write("   *\tTest 4.%02d:  left %d %d Inputs/even Outputs/trash ... "  %(testNumber, shiftBytes, shiftBites))
            if os.system("valgrind --error-exitcode=1 ./testApp left %d %d Inputs/even Outputs/trash >/dev/null 2> Outputs/4.%02d.txt" % (shiftBytes, shiftBites, testNumber)) != 0:
                print "Chyba\n"
            else:
                print "OK\n"   
            
            
    if testChoice == "5" or testChoice == "all":
        print "  -->\tTestovaci sada 5 - kontrola spotreby pameti\n"
        
        calibrationMemSize = 0
        refMemSize = 0
        testMemSize = 0
        
        tokens = re.findall(r'\w+', sys.argv[1])
        #print tokens
        calibration = "calibration"
        if len(tokens) == 2:
            calibration = calibration + "." + tokens[1]
        #print calibration
        if os.system("ps -o pgid= -o pid= -o vsz= -o comm= > /dev/null 2> /dev/null") >> 8 == 1:
            print "  !!!\tChyba: Nemohu provest test spotreby pameti!\n"
            print "\t\tProstredi neumoznuje testovat spotrebu pameti.\n"
            
        elif not perlEnabled:
            print "  !!!\tChyba: Nemohu provest test spotreby pameti!\n"
            print "\t\tInterpret perlu nebyl v systemu nelezen.\n"
#        elif not os.path.exists(calibration):
#            print "  !!!\tChyba: Nemohu provest test spotreby pameti!\n"
#            print "\t\tNemohu nalezt kalibracni soubor 'calibration'.\n"
        else:
            os.system("chmod +x timeout.perl")
            os.system("chmod +x " + calibration)
            sys.stdout.write("   *\tKalibrace mereni pameti ... ")
            if  os.system("./timeout.perl ./" + calibration + " left 33333 3 Inputs/odd /dev/null 2> Outputs/MemoryTest") != 0:
                print "Chyba\n"
                print "  !!!\tNepodarilo se uspesne spustit test spotreby pameti!\n"
            else:
                print "OK\n"
                resultFile = file("Outputs/MemoryTest")
                results = re.findall(r'\w+', resultFile.read(100))
                #print results
                calibrationMemSize = int(results[7])
                
            sys.stdout.write("   *\tMerim spotrebu pameti referencniho reseni ... ")
            if  os.system("./timeout.perl -x 100 ./" + sys.argv[1] + " left 33333 3 Inputs/odd /dev/null 2> Outputs/MemoryTest") != 0:
                print "Chyba\n"
                print "  !!!\tNepodarilo se uspesne spustit test spotreby pameti!\n"
            else:
                resultFile = file("Outputs/MemoryTest")
                results = re.findall(r'\w+', resultFile.read(100))
                #print results
                refMemSize = int(results[7])
                print "%d stranek pameti\n" % (refMemSize - calibrationMemSize)
                
            sys.stdout.write("   *\tMerim spotrebu pameti testovaneho reseni ... ")
            if  os.system("./timeout.perl -x 100 ./testApp left 33333 3 Inputs/odd /dev/null 2> Outputs/MemoryTest") != 0:
                print "Chyba\n"
                print "  !!!\tNepodarilo se uspesne spustit test spotreby pameti!\n"
            else:
                resultFile = file("Outputs/MemoryTest")
                results = re.findall(r'\w+', resultFile.read(100))
                #print results
                testMemSize = int(results[7])
                print "%d stranek pameti\n" % (testMemSize - calibrationMemSize)
        
    if testChoice == "6" or testChoice == "all":
        print "  -->\tTestovaci sada 6 - kontrola rychlosti reseni\n"
        
        if (not os.path.exists("Inputs/odd")) or (not os.path.exists("Inputs/even")):
            sys.stdout.write("   *\tGeneruji nahodne matice ... ")
            generateMatrix("Inputs/odd", oddMatrixSqrtSize * oddMatrixSqrtSize)
            generateMatrix("Inputs/even", evenMatrixSqrtSize * evenMatrixSqrtSize)
            print "OK\n"
            
        shiftBytes = rand.randint(0, oddMatrixSqrtSize * oddMatrixSqrtSize - 1)
        shiftBites = rand.randint(0, 7)
        
        sys.stdout.write("   *\tMerim rychlost referencniho reseni ... " )
        os.system("./%s left %d %d Inputs/even Outputs/6.00ref showSpeed | tail -1 > Outputs/6.00ref.txt" %(sys.argv[1], shiftBytes, shiftBites))
        f = file("Outputs/6.00ref.txt", "r")
        refSpeed = float(f.read(100))
        f.close()
        print "%.2f s\n" % refSpeed
        
        sys.stdout.write("   *\tMerim rychlost testovaneho reseni ... " )
        os.system("./testApp left %d %d Inputs/even Outputs/6.00test showSpeed | tail -1 > Outputs/6.00test.txt" %(shiftBytes, shiftBites))
        f = file("Outputs/6.00test.txt", "r")
        testSpeed = float(f.read(100))
        f.close()
        print "%.2f s\n" % testSpeed
        
        
